package cn.ibizlab.humanresource.core.pcm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.pcm.domain.HRTransferApply;
import cn.ibizlab.humanresource.core.pcm.filter.HRTransferApplySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRTransferApply] 服务对象接口
 */
public interface IHRTransferApplyService extends IService<HRTransferApply>{

    boolean create(HRTransferApply et) ;
    void createBatch(List<HRTransferApply> list) ;
    boolean update(HRTransferApply et) ;
    void updateBatch(List<HRTransferApply> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRTransferApply get(String key) ;
    HRTransferApply getDraft(HRTransferApply et) ;
    boolean checkKey(HRTransferApply et) ;
    boolean save(HRTransferApply et) ;
    void saveBatch(List<HRTransferApply> list) ;
    Page<HRTransferApply> searchDefault(HRTransferApplySearchContext context) ;
    List<HRTransferApply> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    List<HRTransferApply> selectByHrorganizationid2(String organizationid) ;
    void removeByHrorganizationid2(String organizationid) ;
    List<HRTransferApply> selectByHrpostid2(String hrpostid) ;
    void removeByHrpostid2(String hrpostid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRTransferApply> getHrtransferapplyByIds(List<String> ids) ;
    List<HRTransferApply> getHrtransferapplyByEntities(List<HRTransferApply> entities) ;
}


